#!/usr/bin/python

import sys

def convert(source,dest):
	f_orig = file(source,"rb")
	f_dest = file(dest,"wb")

	buff_orig = f_orig.read()
	
	buff_out = ''
	buff_out = buff_out + buff_orig[0x0:0x604]
	buff_out = buff_out + buff_orig[0x608:0x61c]
	buff_out = buff_out + buff_orig[0x620:0xc24]
	buff_out = buff_out + buff_orig[0xc28:0xc3c]
	buff_out = buff_out + buff_orig[0xc40:0x1244]
	buff_out = buff_out + buff_orig[0x1248:0x1edac]
	buff_out = buff_out + buff_orig[0x1f020:0x2001c]

	f_dest.write(buff_out)

	f_orig.close()
	f_dest.close()


usage = """
SYNOPSIS
  ./cave_story_save_converter.py (original_file) (destination_file)
"""

def main():
	if( len(sys.argv)==1 ):
		start_gui()
	elif( sys.argv[1]=='-h' or sys.argv[1]=='--help' ):
		print usage
	elif( len(sys.argv)!=3 ):
		print usage
	else:
		try:
			convert(sys.argv[1],sys.argv[2])
		except:
			print "An error has occured"
		else:
			print "Successfully converted!"

def start_gui():
	import tkMessageBox
	import tkFileDialog 

	source = tkFileDialog.askopenfilename(title="Select original Profile.dat")

	if source=='':
		tkMessageBox.showinfo("","Input file not selected. Press OK to exit")
		return

	dest = ''
	while True:
		dest = tkFileDialog.asksaveasfilename(title="Specify filename for converted file",initialfile="Profile.dat")
		if dest!=source:
			break
		else:
			tkMessageBox.showinfo("","You have specified the same file for input and output. Please, select another filename.")


	try:
		convert(source,dest)
	except:
		tkMessageBox.showinfo("","An error has occured")
	else:
		tkMessageBox.showinfo("","Successfully converted!")



if __name__ == '__main__':
	main()